<?php
/**
 * @version    $version 4.6.1 Peter Bui  $
 * @copyright    Copyright (C) 2012 PB Web Development. All rights reserved.
 * @license    GNU/GPL, see LICENSE.php
 * Updated    15th March 2015
 *
 * Twitter: @astroboysoup
 * Blog: http://nicheextensions.com
 * Email: mail@nicheextensions.com
 *
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgSystemSocialBoostWidget extends JPlugin
{
    function plgSystemSocialBoostWidget(&$subject, $config)
    {
        parent::__construct($subject, $config);
    }

    function onAfterRender()
    {

        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $script = null;
        $query
            ->select('*')
            ->from($db->quoteName('#__socialboost'))
            ->order('id DESC')
            ->setLimit('1');

        $db->setQuery($query);
        $results = $db->loadObjectList();
        if (is_array($results) && count($results) > 0 && $results[0]->register == 1) {
            $user = JFactory::getUser();
            $script = '<input type="hidden" id="gr_gru" name="gr_gru" value="' . $user->email . '" />';
            $script .= '<input type="hidden" id="gr_tab" name="gr_tab" value="1" />';
            $arr['id_site'] = $results[0]->shop_id;
            $arr['error'] = 0;
            $hash = strtr(base64_encode(json_encode($arr)), '+/=', '-_,');
            $script .= ' <script src="https://appsmav.com/social/widgets/widgetJs?acidMav=' . $results[0]->appid . '&cur=&pv_t=' . $hash . '&shop=' . JURI::root() . '&u_log_l=' . JURI::root() . 'index.php/using-joomla/extensions/components/users-component/registration-form" type="text/javascript"></script>';

        }

        $javascript = '';
        $app = JFactory::getApplication();

        if ($app->isAdmin()) {
            return;
        }

        $buffer = JResponse::getBody();

        if ($script) {
            $javascript .= $script;
        }

        $buffer = preg_replace("/<\/body>/", "\n\n" . $javascript . "\n\n</body>", $buffer);
		
			$reg = '\\['                              // Opening bracket
			. '(\\[?)'                           // 1: Optional second opening bracket for escaping shortcodes: [[tag]]
			. "sb-campaign"                     // 2: Shortcode name
			. '(?![\\w-])'                       // Not followed by word character or hyphen
			. '('                                // 3: Unroll the loop: Inside the opening shortcode tag
			.     '[^\\]\\/]*'                   // Not a closing bracket or forward slash
			.     '(?:'
			.         '\\/(?!\\])'               // A forward slash not followed by a closing bracket
			.         '[^\\]\\/]*'               // Not a closing bracket or forward slash
			.     ')*?'
			. ')'
			. '(?:'
			.     '(\\/)'                        // 4: Self closing tag ...
			.     '\\]'                          // ... and closing bracket
			. '|'
			.     '\\]'                          // Closing bracket
			.     '(?:'
			.         '('                        // 5: Unroll the loop: Optionally, anything between the opening and closing shortcode tags
			.             '[^\\[]*+'             // Not an opening bracket
			.             '(?:'
			.                 '\\[(?!\\/\\2\\])' // An opening bracket not followed by the closing shortcode tag
			.                 '[^\\[]*+'         // Not an opening bracket
			.             ')*+'
			.         ')'
			.         '\\[\\/\\2\\]'             // Closing shortcode tag
			.     ')?'
			. ')'
			. '(\\]?)';                          // 6: Optional second closing brocket for escaping shortcodes: [[tag]]

		
		
		$buffer = preg_replace_callback( "/$reg/", array('plgSystemSocialBoostWidget', 'do_shortcode_tag'), $buffer );
		
		
		
        JResponse::setBody($buffer);

        return true;
    }
	
	function do_shortcode_tag( $m ) {
			$result = $this->shortcode_parse_atts($m[2]);
			$replace_string  = '<script src="https://appsmav.com/social/assets/js/iframeResizer.min.js" type="text/javascript"></script>';
			$replace_string .= '<iframe src="https://appsmav.com/social/contest/play/'.$result['id'].'?is_iframe=1" height="'.$result['height'].'" width="'.$result['width'].'" scrolling="'.$result['scroll'].'" frameBorder="0" class="iframeMav"> </iframe>';
			$replace_string .= '<script>	jQuery(".iframeMav").iFrameResize({ checkOrigin : false}); </script>';
			return $replace_string;
	}
	
	function shortcode_parse_atts($text) {
	$atts = array();
	$pattern = $this->get_shortcode_atts_regex();
	$text = preg_replace("/[\x{00a0}\x{200b}]+/u", " ", $text);
	if ( preg_match_all($pattern, $text, $match, PREG_SET_ORDER) ) {
		foreach ($match as $m) {
			if (!empty($m[1]))
				$atts[strtolower($m[1])] = stripcslashes($m[2]);
			elseif (!empty($m[3]))
				$atts[strtolower($m[3])] = stripcslashes($m[4]);
			elseif (!empty($m[5]))
				$atts[strtolower($m[5])] = stripcslashes($m[6]);
			elseif (isset($m[7]) && strlen($m[7]))
				$atts[] = stripcslashes($m[7]);
			elseif (isset($m[8]))
				$atts[] = stripcslashes($m[8]);
		}

		// Reject any unclosed HTML elements
		foreach( $atts as &$value ) {
			if ( false !== strpos( $value, '<' ) ) {
				if ( 1 !== preg_match( '/^[^<]*+(?:<[^>]*+>[^<]*+)*+$/', $value ) ) {
					$value = '';
				}
			}
		}
	} else {
		$atts = ltrim($text);
	}
	return $atts;
}


function get_shortcode_atts_regex() {
	return '/([\w-]+)\s*=\s*"([^"]*)"(?:\s|$)|([\w-]+)\s*=\s*\'([^\']*)\'(?:\s|$)|([\w-]+)\s*=\s*([^\s\'"]+)(?:\s|$)|"([^"]*)"(?:\s|$)|(\S+)(?:\s|$)/';
}
	
}

